import { Elysia } from 'elysia'
import db from '../Database'
import { User } from './index.ts'
import { authenticator } from 'otplib';

const user = new User();

const userController = new Elysia()
    .get('/', ({user}) => {
        return user
    })
    .post('/login', async ({ body }) => {
        const msg = db.query(`select id, password, administrator, otp from users WHERE username = ?;`)
            .get(body.username)
        console.log(msg)
        if(msg == null) return new Response("Invalid username or password", { status: 401 })
        const validPassword = await Bun.password.verify(body.password, msg.password)
        if (!validPassword) return new Response("Invalid username or password", { status: 401 })
        // if(!authenticator.check(body.otp, msg.otp)) return new Response("Invalid OTP code", { status: 401 })
        if(msg.administrator == 1) {return new Response(await user.createToken(msg.id), {status: 418})}
        return await user.createToken(msg.id)
    })
    .put('/password', ({user}, body) => {
        const oldPassword = body.oldPassword;
        const newPassword = body.newPassword;
        if (oldPassword == "" || newPassword == "") {
            {return new Response("Bad password", {status: 400})}
        }

        const msg = db.query(`select password from users WHERE id = ?;`).get(user.id);
        if(!Bun.password.verify(oldPassword, msg.password)) {
            {return new Response("Bad old password", {status: 400})}
        }
        const newPasswordHash = Bun.password.hash(body.newPassword)
        db.query(`update users set password = ? WHERE id = ?;`).run(newPassword. user.id);
        "password updated"
    })

export default userController
